unit mt_Logger;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, Forms, StdCtrls;

const
  DATETIMEFMT = 'yyyy"-"mm"-"dd hh":"mm":"ss';
  DATEONLYFMT = 'yyyy"-"mm"-"dd';
  NODATEFMT = '';

type

//  TLogLevel = ( llNone = 0, llInfo, llDebug, llWarn, llError, llFatal, llAll );

  TLogLevel = ( llNone = 0, llInfo, llFatal, llError, llDebug, llWarn, llAll );

  TLogLevels = set of TLogLevel;


  { === TNewLogger === }
  TLogger = class
  private
    FLogLBx: TListBox;
    FLogLevel: TLogLevel;
    FLogFilename: string;

    procedure SetLogGUI(aLogLBx: TListBox);
//    procedure SetLogFilename(aFilename: string);
    procedure SetLogLevel(aLogLevel: TLogLevel);

  public
    property LogLBx: TListBox read FLogLBx write SetLogGUI;
    property LogLevel: TLogLevel read FLogLevel write FLogLevel;
    property LogFilename: String read FLogFilename write FLogFilename;

    constructor Create;

    procedure LogMsg(aLogMsg: string);
    procedure LogMsg(aLogLevel: TLogLevel; aLogMsg: string);

    //procedure LogMsgFile(aLogLevel: TLogLevel; aLogText: string);

  end;

var
  Logger: TLogger;

implementation

//uses
//  sb_Defs;

function NowFormated: String;
begin
  result := FormatDateTime(DATETIMEFMT,now);
end;


// TLogger-Class
// =============
constructor TLogger.Create;
begin
//  FLogLBx := aLogLBx;
  FLogLevel := llError;
  FLogFilename := 'LogFile.log';
end;


procedure TLogger.SetLogGUI(aLogLBx: TListBox);
begin
  FLogLBx := aLogLBx;
end;


//procedure TLogger.SetLogFilename(aFilename: string);
//begin
//  FLogFilename := aFilename;
//end;


procedure TLogger.SetLogLevel(aLogLevel: TLogLevel);
begin
  FLogLevel := aLogLevel;
end;


// LogMsg(aLogMsg: string);
// calling LogMsg w/o loglevel will call LogMsg(llNone, ...)
procedure TLogger.LogMsg(aLogMsg: string);
begin
  LogMsg(llNone,aLogMsg);
end;


procedure TLogger.LogMsg(aLogLevel: TLogLevel; aLogMsg: string);
var
  dateStr, lvlStr: string;
begin
  if aLogLevel <= FLogLevel then
  begin
    case aLogLevel of
      llNone:   lvlStr := '';         // z.B. zur Ausgabe direkt in Fenster,Panel oder Statusleiste
      llInfo:   lvlStr := '[ INFO]';
      llFatal:  lvlStr := '[FATAL]';
      llError:  lvlStr := '[ERROR]';
      llDebug:  lvlStr := '[DEBUG]';
      llWarn:   lvlStr := '[ WARN]';
      llAll:    lvlStr := '[     ]';  // sollte so nicht verwendet werden
    end;

    dateStr := NowFormated + ':';

    if (aLogLevel = llNone) or (aLogLevel = llInfo) then
      dateStr := '';        // kein Zeit-Stempel z.B. zur Ausgabe direkt in Fenster,Panel oder Statusleiste

    FLogLBx.Items.Add(Format('%s%s%s',[dateStr,lvlStr,aLogMsg]));
    FLogLBx.TopIndex := FLogLBx.Count-1;
  end;
end;


end.

