unit mt_iter;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils;

type
  TRoot = class
    xvalue: double;
    prec: double;
    root: double;
    iterations: integer;
  end;


procedure DoIterations;
procedure IterateRoot(var CalcRoot: TRoot);



implementation


procedure DoIterations;
begin

end;


{ the workload for the thread }
{ IterateRoot: calc root of value bei iteration
  Input parameter and result (root, no iterations in var parameter CalcRoot
}
procedure IterateRoot(var CalcRoot: TRoot);
const
  MAXITER = 100;
  DELAY = 10000000;    // adjusted to get reasonable execution times to measure
var
  i, j: integer;
  x, root, delta, square: double;
begin
  for j:=0 to DELAY do
  begin

    x := CalcRoot.xvalue;
    root := x / 2;      // 1st guess
    delta := root / 2;
    i := 0;

    repeat
      square := root * root;

      if square - x > 0.0 then
        root := root - delta
      else if square - x < 0.0 then
        root := root + delta;

      inc(i);
      delta := delta / 2;

    until (Abs((square-x)/x) < CalcRoot.prec) or (i > MAXITER);
  end;

  // save the results (root, iterations used) in structure TRoot
  CalcRoot.root := root;
  CalcRoot.iterations := i;
end;


end.

